'
'  Login.BAS Example Program
'

'$INCLUDE: 'PCL4B.BI'
'$INCLUDE: 'MODEM_IO.BI'

 DECLARE SUB MyExit (Port)
 DECLARE FUNCTION Login (Port, Send$, Pace, Expect$, Tics)

 Buf256$ = STRING$(256+16,0)  'must be 1st string statement
 BufSeg = (1+SSEG(Buf256$)) + (SADD(Buf256$) \ 16)

 CONST FALSE = 0, TRUE = NOT FALSE
 Const ESC = 27
 Dim RATES$(12)

 RATES$(1) = "300"
 RATES$(2) = "600"
 RATES$(3) = "1200"
 RATES$(4) = "2400"
 RATES$(5) = "4800"
 RATES$(6) = "9600"
 RATES$(7) = "19200"
 RATES$(8) = "38400"
 RATES$(9) = "57600"
 RATES$(10) = "115200"

 PARMS$ = RTRIM$(COMMAND$)
 I = INSTR(PARMS$, " ")
 IF I < 1 THEN
   PRINT "  Usage: Login <Port> <BaudRate>"
   PRINT "Example: Login 1 9600"
   END
 END IF
 L = LEN(PARMS$)
 ARG1$ = LEFT$(PARMS$, I - 1)
 ARG2$ = LTRIM$(RIGHT$(PARMS$, L - I))
 BaudCode = -1
 'Get COM port
 Port = VAL(ARG1$) - 1
 'Get baud code
 FOR I = 1 TO 10
   IF RATES$(I) = ARG2$ THEN
      BaudCode = I - 1
      EXIT FOR
   END IF
 NEXT I
 'Verify good baud rate
 IF BaudCode = -1 THEN
   PRINT "Cannot recognize baud rate "; ARG2$
   END
 END IF
'Reset port
 Code = SioRxBuf(Port, BufSeg, Size256)
 IF Code < 0 THEN
   PRINT "Error "; Code; " returned from SioRxBuf()"
   Code = SioError(Code)
   END
 END IF
 Code = SioReset(Port, BaudCode)
 CLS
 IF Code < 0 THEN
   PRINT "Error "; Code; " returned from SioReset()"
   Code = SioError(Code)
   END
 END IF

 PRINT "Login 7/29/94"
 PRINT " "
 LIBVER = SioInfo(ASC("V"))
 PRINT "Library Version: "; LIBVER \ 16; ".";
 PRINT LIBVER - 16 * (LIBVER \ 16)

 Code = SioDTR(Port, SET_LINE)
 Code = SioRTS(Port, SET_LINE)

 'send "AT" to modem & expect "OK" back
 IF NOT Login(Port, "!AT!", 5, "OK", 180) THEN MyExit (Port)
 'initialize modem & expect "OK" back
 IF NOT Login(Port, "AT E1 S7=60 S11=60 V1 X1 Q0 S0=1!", 5, "OK", 90) THEN MyExit (Port)
 'send "ATDT1,205,880,9748" & expect "CONNECT" back
 IF NOT Login(Port, "ATDT1,205,880,9748!", 5, "CONNECT", 1092) THEN MyExit (Port)
 PRINT "Entering TERMINAL loop..."

 DO
   'Look at incoming serial
   Code = SioGetc(Port, 1)
   IF Code > -1 THEN
     Code = SioCrtWrite(Code)
   END IF
   'Anything to send
   AnyKey$ = INKEY$
   IF AnyKey$ <> "" THEN Code = SioPutc(Port, ASC(AnyKey$))
   IF AnyKey$ = CHR$(ESC) THEN EXIT DO
 LOOP

 PRINT "User typed ESC..."
 MyExit (Port)

 END


 Function Login (Port, Send$, Pace, Expect$, Tics)
 rc = ModemSendTo(Port, Pace, Send$)
 If ModemWaitFor(Port, Tics, False, Expect$) Then
   Print
   Login = True
 Else
   Print Expect$; " not received"
   Login = False
 End If
 End Function

 Sub MyExit (Port)
 rc = SioDone(Port)
 End
 End Sub

