 '
 ' Process ESC
 '

 DefInt A-Z

'$INCLUDE: 'PROCESS.BI'
'$INCLUDE: 'TERM_IO.BI'
'$INCLUDE: 'PCL4B.BI'
'$INCLUDE: 'XYMODEM.BI'

CONST FALSE = 0, TRUE = NOT FALSE
Const NAK = &H15

Dim Shared ThePort
Dim Shared Protocol$
Dim Shared OneKflag
Dim Shared NCGbyte
Dim Shared BatchFlag
Dim Shared BaudRate$

Sub InitProcess (ByVal ThePort, Baud$)
  Port = ThePort
  BaudRate$ = Baud$
  Protocol$ = "X"
  OneKflag = False
  NCGbyte = NAK
  BatchFlag = False
End Sub

Function Process ()
  Process = False
  GetNameMsg$ = "Enter filename: "
  'quit if user types ESC
  If True Then
    Call WriteMsg("Q)uit P)rotocol S)end R)eceive: ", 1)
    Call ReadMsg(ResultMsg$, 32, 1)
    C$ = UCase$(Left$(ResultMsg$, 1))
    Select Case C$
      Case "Q"   'QUIT
        Print
        Print ("TERMINATING: User pressed <ESC>")
        RetCode = SioDone(ThePort)
        Process = True
        Exit Function
      Case "P"   'PROTOCOL
        Call WriteMsg("X)modem Y)modem ymodem-G): ", 1)
        Call ReadMsg(ResultMsg$, 35, 1)
        P$ = UCase$(Left$(ResultMsg$, 1))
        Select Case P$
          Case "X"  'XMODEM
            Protocol$ = "X"
            OneKflag = False
            NCGbyte = NAK
            BatchFlag = False
            Call WriteMsg("Protocol = XMODEM", 1)
          Case "Y"  'YMODEM
            Protocol$ = "Y"
            OneKflag = True
            NCGbyte = Asc("C")
            BatchFlag = True
            Call WriteMsg("Protocol = YMODEM", 1)
          Case "G"  'YMODEM-G
            Protocol$ = "G"
            OneKflag = True
            NCGbyte = Asc("G")
            BatchFlag = True
            Call WriteMsg("Protocol = YMODEM-G", 1)
        End Select
        Call ShowStatus
        'StatusMsg$ = "COM" + STR$(ThePort) + " " + Prococol$ + "  ESC for menu"
        'CALL WriteMsg(StatusMsg$, 40)
      Case "R"  'Receive
        Filename$ = ""
        If BatchFlag Then
          Flag = YmodemRx(ThePort, Filename$, NCGbyte)
        Else
          Flag = XmodemRx(ThePort, Filename$, NCGbyte)
        End If
      Case "S"  'Send
        Filename$ = ""
        If BatchFlag Then
          Flag = YmodemTx(ThePort, Filename$, OneKflag)
        Else
          Flag = XmodemTx(ThePort, Filename$, OneKflag)
        End If
      Case Else
        Call WriteMsg("Bad response", 1)
     End Select
   End If
 End Function

Sub ShowStatus ()
  P$ = Str$(1 + ThePort)
  StatusMsg$ = "COM" + Right$(P$, Len(P$) - 1) + " " + BaudRate$ + " " + Protocol$ + " ESC for menu"
  Call WriteMsg(StatusMsg$, 45)
End Sub

